### Persephone - a socio-economic-ecological model of European agricultural landscapes.
###
### This is the top-level file of the Persephone test suite. Execute this to run all tests.
###

using Pkg
Pkg.activate("..")

using Persephone
using Test
using Random
using Logging
using Dates
using Agents

const Ps = Persephone

const TESTPARAMETERS = "test_parameters.toml"

@testset "Persephone Tests" begin
    Ps.initsettings(TESTPARAMETERS)
    @testset "Core model" begin
        include("io_tests.jl")
        include("landscape_tests.jl")
        include("simulation_tests.jl")
    end
    @testset "Nature model" begin
        include("nature_tests.jl")
    end
    @testset "Crop growth model" begin
        include("crop_tests.jl")
    end
    @testset "Farm model" begin
        include("farm_tests.jl")
    end
    rm(param("core.outdir"), force=true, recursive=true)
end
